/*
Demonstrate the use of:
1. fields
2. constructors
3. methods
4. and that a method can have a formal parameter that is an object rather than a primitive.
*/
// DEFINITION
class Box
{
  double width, height, depth;
  double volume; // width * height * depth;

  // constructor taking primitive parameters
  Box(double w, double h, double d)
  {
	  volume = w * h * d;
  }

  // parameterless method
  double getVolume()
  {
	return volume;
  }

  // object parameter
  void enlargeBox(Box b)
  {
	 volume *= 2;
	 System.out.println("This method specifies a formal parameter of type Box, \nso the runtime call must pass in a reference to a Box object.");
  }
}
// RUNTIME
class BoxEnlargerDemo
{
  public static void main(String[] args)
  {
	double volume;
    Box myBox1 = new Box(1, 2, 3);
    Box myBox2 = new Box(1.5, 2.5, 3.5);

    System.out.println(myBox1.getVolume());
    System.out.println(myBox2.getVolume());
    myBox2.enlargeBox(myBox1); // object argument
    System.out.println(myBox2.getVolume());
  }
}