class Book
{
  String title = "placeholder"; // avoid a null string
}

class CopyByReferenceDemo
{
  public static void main(String[] args)
  {
      Book myBook = new Book();
      myBook.title = "Gone With the Hurricane";
      System.out.println(myBook.title);

      Book yourBook = new Book();
      System.out.println(yourBook.title + " is the title of the yourBook object");

      boolean isSameTitle = myBook.title.equals(yourBook.title);

      System.out.println("Do the books have the same title? " + isSameTitle);

      System.out.println("assign both variables to the same object with yourBook = myBook;");
      yourBook = myBook; // two variables refer to same String object
      System.out.println(yourBook.title + " is the title of the yourBook object and " + myBook.title + " is the title of myBook");

      System.out.println("Are the books the same object? " + (myBook == yourBook));

      isSameTitle = myBook.title.equals(yourBook.title);

      System.out.println("Do the books have the same title? " + isSameTitle);

	  // By calling the constructor and "new", a new memory space is allocated
      Book thirdBook = new Book();
	  thirdBook.title = "Gone With the Hurricane";
      System.out.println(thirdBook.title);

      System.out.println("Is thirdBook the same object as myBook? " + (thirdBook == myBook));

	  isSameTitle = thirdBook.title.equals(myBook.title);

      System.out.println("Does thirdBook have the same title as myBook? " + isSameTitle);

      // primitives copy by value, not by reference,
      // here we have local values, not fields, and we do not use the dot operator to reference them
      int myValue = 10;
      int yourValue = 20;
      System.out.println("myValue is:  " + myValue);
      System.out.println("yourValue is " + yourValue);
      myValue = yourValue;
      System.out.println("myValue is:  " + myValue);
      System.out.println("yourValue is " + yourValue);
      yourValue = yourValue + 100; // yourVal not bound to myVal
      System.out.println("myValue is:  " + myValue);
      System.out.println("yourValue is " + yourValue);
  }
}