class Power
{
  double b; // default is 0.0
  int e, unassignedInt; // default is 0
  double value, unassignedDouble;
  boolean myBool; // default is false
  String myString; // default is null

  Power(double b, int exponent)
  {
    // b = b; / NOT GOOD because object's field not assigned a value, so keeps default 0.0
    this.b = b; // assign a non-default value to the object's field
    e = exponent;

    value = 1;
    if(exponent==0) return;
    for( ; exponent>0; exponent--)
    {
      value = value * b;
    }
  }

  double getPower()
  {
    return value;
  }
}

class DemoPowerUsingThis
{
  public static void main(String[] args)
  {
    Power x = new Power(4.0, 2);
    Power y = new Power(2.5, 1);
    Power z = new Power(5.7, 0);

    System.out.println(x.b + " raised to the " + x.e +
       " power is " + x.getPower());
    System.out.println(y.b + " raised to the " + y.e +
       " power is " + y.getPower());
    System.out.println(z.b + " raised to the " + z.e +
       " power is " + z.getPower());
    System.out.println("Default value for a boolean field is " + x.myBool);
    System.out.println("Default value for a double field is " + x.unassignedDouble + " and the default value of a int field is " + x.unassignedInt);
    System.out.println("Default value for a String field is " + x.myString);
  }
}