/*
finalize() has been invoked by the JVM - Finalizing at object count of 447730
finalize() has been invoked by the JVM - Finalizing at object count of 450530
finalize() has been invoked by the JVM - Finalizing at object count of 450677
finalize() has been invoked by the JVM - Finalizing at object count of 450823
finalize() has been invoked by the JVM - Finalizing at object count of 450959
finalize() has been invoked by the JVM - Finalizing at object count of 451093
*/
class FinalizeDemo
{
  int count; // instance variable to track how many instances are constructed

  FinalizeDemo(int i)
  {
    count = i;
    // System.out.println("We could close a file or database connection with this override.");
    // IF THE CONSTRUCTOR ALSO BUILDS A STRING, MEMORY NEEDS TO BE FREED MORE OFTEN
  }

  // this override called when object is recycled by the garbage collector
  protected void finalize()
  {
    System.out.println("finalize() has been invoked by the JVM - Finalizing at object count of " + count);
  }

  // method to generate an object that takes runtime arg to track how many objects have been created
  void objectGenerator(int count)
  {
    FinalizeDemo myObject = new FinalizeDemo(count);
  }
}

class Finalize
{
  public static void main(String[] args)
  {
    int count;

    FinalizeDemo ob = new FinalizeDemo(0);

    // JVM will clean up objects periodically, but not under our control
    for(count=1; count < 583000; count++)
    {
		ob.objectGenerator(count);
	}
  }
}
/*
// IF THE CONSTRUCTOR ALSO BUILDS A STRING, MEMORY NEEDS TO BE FREED MORE OFTEN:
finalize() has been invoked by the JVM - Finalizing at object count of 359412
We could close a file or database connection with this override.
We could close a file or database connection with this override.
We could close a file or database connection with this override.
We could close a file or database connection with this override.
We could close a file or database connection with this override.
We could close a file or database connection with this override.
We could close a file or database connection with this override.
finalize() has been invoked by the JVM - Finalizing at object count of 359413
We could close a file or database connection with this override.
We could close a file or database connection with this override.
We could close a file or database connection with this override.
finalize() has been invoked by the JVM - Finalizing at object count of 359414
// HERE, CLEAN UP OCCURS AT EACH OBJECT CREATION, BUT CLEAN UP LAGS BEHIND OBJECT CREATION.
// THE GARBAGE COLLECTOR IS SLOWER THAN THE CONSTRUCTOR.
*/