/*
   Add a parameterized method that computes the
   fuel required for a given distance.
*/
class Vehicle
{ // fields
  int numberOfPassengers;
  int fuelCapacity;
  int efficiencyInMpg;

  // Return the range.
  int getRange()
  {
    return efficiencyInMpg * fuelCapacity;
  }

  // method definition specifies a formal parameter of type int
  // and a return type of double
  double getFuelNeeded(int miles) {
    return (double) miles / efficiencyInMpg;
  }
}

class FuelNeededCalculator
{
  public static void main(String[] args)
  {
    Vehicle minivan = new Vehicle();
    Vehicle sportscar = new Vehicle();
    double gallons;
    int distance = 252;

     // assign values to fields in minivan
    minivan.numberOfPassengers = 7;
    minivan.fuelCapacity = 16;
    minivan.efficiencyInMpg = 21;

    // assign values to fields in sportscar
    sportscar.numberOfPassengers = 2;
    sportscar.fuelCapacity = 14;
    sportscar.efficiencyInMpg = 12;

    gallons = minivan.getFuelNeeded(distance);

    System.out.println("To go " + distance + " miles minivan needs " +
                       gallons + " gallons of fuel.");

    gallons = sportscar.getFuelNeeded(distance);

    System.out.println("To go " + distance + " miles sportscar needs " +
                       gallons + " gallons of fuel.");

  }
}
