/* Demonstrate that a constructor initializes an object in a valid state
   so that methods called on the properly-initialized object at runtime
   can provide valid results
*/
class Scientist
{
	boolean abilityToObserve;
	boolean abilityToTheorize;

	Scientist(int yearOfBirth)
	{
		abilityToObserve = true;
		abilityToTheorize = true;
		System.out.println("I am a scientist object, and my unique ID in the JVM is: "
		+  this.hashCode());
	}

	void inventTelescope()
	{
		System.out.println("This is " + this.hashCode()
		+ " and I use two lenses to look up at stars the sky.");
	}

	void inventMicrosope()
	{
		System.out.println("This is " + this.hashCode()
		+ " and I use two lenses to look down at bacteria swimming in water.");
	}
}

class ScientistDemo
{
	public static void main(String[] args)
	{
			Scientist galileo = new Scientist(1564);
			Scientist leeuwenhoek = new Scientist(1632);

		 	galileo.inventTelescope();
		 	leeuwenhoek.inventMicrosope();
	}
}